Subject: Re: [PATCH net v3] ppp: fix refcount underflow on channel unbridge

From: Guillaume Nault <[email-masked]>
Date: Fri, 8 Jan 2021 21:57:50 +0100

On Thu, Jan 07, 2021 at 06:13:15PM +0000, Tom Parkin wrote:
> When setting up a channel bridge, ppp_bridge_channels sets the
> pch->bridge field before taking the associated reference on the bridge
> file instance.
> 
> This opens up a refcount underflow bug if ppp_bridge_channels called
> via. iotcl runs concurrently with ppp_unbridge_channels executing via.
> file release.
> 
> The bug is triggered by ppp_bridge_channels taking the error path
> through the 'err_unset' label.  In this scenario, pch->bridge is set,
> but the reference on the bridged channel will not be taken because
> the function errors out.  If ppp_unbridge_channels observes pch->bridge
> before it is unset by the error path, it will erroneously drop the
> reference on the bridged channel and cause a refcount underflow.
> 
> To avoid this, ensure that ppp_bridge_channels holds a reference on
> each channel in advance of setting the bridge pointers.

Thanks for following up on this!

Acked-by: Guillaume Nault <[email-masked]>